% %
% Mychorriza Example
%
% Copyright 2014-2015 Daniel Leitner & Andrea Schnepf. See license.txt for details.
%
% To do: getsusceptible error, dead hyphae, make them white so video shows
% dynamic of growth and death

clear all;

rng(1);   %help fate

set(0,'RecursionLimit',10000);

%-----------------------------------------
% Tap root
%-----------------------------------------
% 
p{1}.r = [2.8293 0]; % Initial elongation rate (cm/day)
p{1}.a = [0.0286 0.0030]; % Root radius (cm)  
p{1}.lb = [2.5861 2.6300]; %[2.59, 2.63]; % Length of basal zone (cm)        
p{1}.la = [4.3318 4.6081];  %[4.33, 4.6]; % Length of apical zone (cm)                    
p{1}.ln = [0.2643 0.2376]; % Length between laterals (cm)
p{1}.nob = [178 0]; % Maximal number of laterals (1)
p{1}.name = 'Tap root'; % Name of the root type
p{1}.color = [0, 1, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (1: 2:)
N = 1.5; % Strength of tropism
sigma = 0.2; % Expected change of root tip heading (rad/cm)
p{1}.tropism = [type, N, sigma]; % Root tropism
p{1}.dx = 0.1; % Spatial resolution along root axis (cm)
p{1}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{1}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)
p{1}.theta = [0, 0]; % Insertion angle (rad)
p{1}.successor = [2, 1]; % Laterals [type,probability;type,probability;...]
% p{1}.ief = @(x) 1; % impede elongation function: scales root elongation
% p{1}.ibf = @(x) 1; % impede branching function: scales branching probability 
% p{1}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

%-----------------------------------------
% Laterals 
%-----------------------------------------

p{2}.r = [0.9793 0.2884]; % Initial elongation rate (cm/day)
p{2}.a = [0.0232 0.0072]; % Root radius (cm)  
p{2}.theta = [1.4066 0]; % Insertion angle (rad) 0.7971
p{2}.lb = [1.0389 1.2431]; % Length of basal zone (cm)        
p{2}.la = [1.6336 1.6889]; % Length of apical zone (cm)                    
p{2}.ln = [0.8192 1.5344]; % Length between laterals (cm)
p{2}.nob = [2 0]; % Maximal number of laterals (1)
%p{2}.name = 'Lateral'; % Name of the root type
p{2}.color = [0, 1, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (1: 2:)
N = 1; % Strength of tropism
sigma = 0.3; % Expected change of root tip heading (rad/cm)
p{2}.tropism = [type, N, sigma]; % Root tropism
p{2}.dx = 0.1; % Spatial resolution along root axis (cm)
p{2}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{2}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)
p{2}.successor = [3, 1]; % Laterals [type,probability;type,probability;...]
% p{2}.ief = @(x) 1; % impede elongation function: scales root elongation
% p{2}.ibf = @(x) 1; % impede branching function: scales branching probability 
% p{2}.irlf = @(x) 1; % impede root life: scales root age regarding root life time
% 
%-----------------------------------------
% Second order laterals
%-----------------------------------------

p{3}.r = [1.5416 0.2774]; % Initial elongation rate (cm/day)
p{3}.a = [0.0148 0.0042]; % Root radius (cm)  
p{3}.theta = [1.4756 0]; % Insertion angle (rad) 0.8940
p{3}.la = [0.59, 0.78]; % Length of root (cm)                    
p{3}.lb = [0, 0]; % Length of basal zone (cm)        
p{3}.ln = [0, 0]; % Length between laterals (cm)
p{3}.nob = [0, 0]; % Maximal number of laterals (1)
%p{3}.name = 'Second order lateral'; % Name of the root type
p{3}.color = [0.5, 0.5, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (1: 2:)
N = 0; % Strength of tropism
sigma = 0.4; % Expected change of root tip heading (rad/cm)
p{3}.tropism = [type, N, sigma]; % Root tropism
p{3}.dx = 0.1; % Spatial resolution along root axis (cm)
p{3}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{3}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)
%
% Mycorrhiza
%
m{1}.name = 'hyphae';
m{1}.r  = [0.13,0];      % tip elongation rate (cm/d) Schnepf 2008a                                      
m{1}.la  = [10,0];         % from ???    we don't need this parameter for hyphae!!!               
m{1}.a  = [0.005,0];       % from Ezawa 2002 
m{1}.b = [0.5, 0.05];  % tip branching rate (1/d) Schnepf 2008a  
m{1}.vi = [0.13, 0];       % speed of internal spread (cm/d) (secondary infection) Amijee et al. 1993, 1986
m{1}.theta = [0,0];      % ???
m{1}.theta_dicho = [30*pi/180,3*pi/180]; % estimated after Bago 1998
m{1}.color = [1 0 1];  
m{1}.tropism = [1,0,40*pi/180];   % ???
m{1}.dx = 0.05;           
m{1}.rlt = [10,0];                % should be 6 days? How to deal with dead hyphae?
m{1}.gf = 2; % linear growth
boxX=10; 
boxY=10; 
boxZ=10;
dfunc = @(p) distPot(p,4,3.15,7.5);

 p=completeParameters(p,dfunc);
 completeMycParameters(m);

% initialize root system
root = createRootSystem(0,0,zeros(1,1)); 
str = root;

% run mycsimulation
simtime = 9                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ;   % simulation time  
minAge = 0;      
maxAge = 32;   % age when root segments are susceptible
P = 1;       % probability of primary infecetion,  1 if placed inocculum, 0.15 if dispersed inocculum
maxInfection = 1;   % Amijee et al. 1993
dt = 0.2; 


[slides,perInf,tta,tea] = simulateMyc_placed_pot(str,simtime,minAge,maxAge,P,maxInfection,dt,true,0);
%str = applyRules(str,simtime);
slidesFirst=slides;
str=slides{end};



%% second phase with increased root growth
%-----------------------------------------
% Tap root
%-----------------------------------------
% 
p{1}.r = [4.2292 2.6709]; % Initial elongation rate (cm/day)
p{1}.a = [0.0386 0.0117]; % Root radius (cm)  
p{1}.lb = [0.4360 0.3932]; %[2.59, 2.63]; % Length of basal zone (cm)        
p{1}.la = [4.5310 3.2402];  %[4.33, 4.6]; % Length of apical zone (cm)                    
p{1}.ln = [0.1805 0.2279/10]*2; % Length between laterals (cm)
p{1}.nob = [180 0]; % Maximal number of laterals (1)
p{1}.name = 'Tap root'; % Name of the root type
p{1}.color = [0, 1, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (1: 2:)
N = 1.5; % Strength of tropism
sigma = 0.2; % Expected change of root tip heading (rad/cm)
p{1}.tropism = [type, N, sigma]; % Root tropism
p{1}.dx = 0.1; % Spatial resolution along root axis (cm)
p{1}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{1}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)
p{1}.theta = [0, 0]; % Insertion angle (rad)
p{1}.successor = [2, 1]; % Laterals [type,probability;type,probability;...]
% p{1}.ief = @(x) 1; % impede elongation function: scales root elongation
% p{1}.ibf = @(x) 1; % impede branching function: scales branching probability 
% p{1}.irlf = @(x) 1; % impede root life: scales root age regarding root life time

%-----------------------------------------
% Laterals 
%-----------------------------------------

p{2}.r = [0.7347 0.0923]; % Initial elongation rate (cm/day)
p{2}.a = [0.0381 0.034/10]/1.5; % Root radius (cm)  
p{2}.theta = [1.5059 1.0556/10]; % Insertion angle (rad) 0.7971
p{2}.lb = [0.6734 0.9455]; % Length of basal zone (cm)        
p{2}.la = [1.0503 1.3501]; % Length of apical zone (cm)                    
p{2}.ln = [0.4093 0.5796]; % Length between laterals (cm)
p{2}.nob = [6 0]; % Maximal number of laterals (1)
%p{2}.name = 'Lateral'; % Name of the root type
p{2}.color = [0, 1, 0]; % Color of the root (rgb)
type = 1; % Type of tropism (1: 2:)
N = 1; % Strength of tropism
sigma = 0.3; % Expected change of root tip heading (rad/cm)
p{2}.tropism = [type, N, sigma]; % Root tropism
p{2}.dx = 0.1; % Spatial resolution along root axis (cm)
p{2}.rlt = [Inf, 0]; % Maximal root life time [mean, std] (days)
p{2}.gf = 1; % Type of growth function (1: negative exponential, 2: linear)
p{2}.successor = [3, 1]; % Laterals [type,probability;type,probability;...]
% p{2}.ief = @(x) 1; % impede elongation function: scales root elongation
% p{2}.ibf = @(x) 1; % impede branching function: scales branching probability 
% p{2}.irlf = @(x) 1; % impede root life: scales root age regarding root life time
% 
%-----------------------------------------
% Second order laterals
%-----------------------------------------

p{3}.r = [1.7793 0.0645]; % Initial elongation rate (cm/day)
p{3}.a = [0.0230 0.0097/10]; % Root radius (cm)  
p{3}.theta = [1.4497 0.8946/5]; % Insertion angle (rad) 0.8940
p{3}.la = [0.4453 0.6823]*2; % Length of root (cm)                    
p{3}.lb = [0.2632 0.4743]*2; % Length of basal zone (cm)        
p{3}.ln = [0.5287 0.7417]*2; % Length between laterals (cm)

p=completeParameters(p);
simtime=46; dt=1;
for i=1:simtime
    [slides,perInf,tta,tea] = simulateMyc_placed_pot(str,1,minAge,maxAge,P,maxInfection,dt,false,9+i-1);
    str = slides{end};
    out{i} = str;
    save([pwd '\results_potRL']);
end

% run AnalyseResults instead....
